;;; -*- Syntax: Ansi-Common-Lisp; Base: 10; Mode: lisp; Package: wco -*-
;;; $Id: test-join.lisp,v 1.2 2002/10/31 14:55:29 craig Exp $
;;;
;;; Copyright (c) 2000, 2001, 2002 onShore Development, Inc.

(in-package :sql-sys)

;; Preliminary definitions for our tests to work on
;; from Marcus Pearce <ek735@soi.city.ac.uk>

;; These testshould be rewritten so the view-classes aredefinedwithin
;; the sql-tests schema, andthere creation/deletion will then be
;; handled properly.  They should also use randomor some other
;; mechanism to creat new OIDs for their joins to key on, so that they
;; can run against a DB multiple times without requiring the fields to
;; be flushed.

(sql:def-view-class view-class1 ()
  ((id1
    :db-kind :key
    :db-constraints :not-null
    :type integer
    :initarg :id1)
   (id2
    :db-kind :key
    :db-constraints :not-null
    :type integer
    :initarg :id2)
   (tests
    :db-kind :join
    :accessor vc1-tests
    :db-info (:join-class view-class2
                          :home-key (id1 id2)
                          :foreign-key (id1 id2)
                          :set t)))
  (:base-table view-class1))

;; a view class which is the target of the above join 
(sql:def-view-class view-class2 ()
  ((id1 
    :db-kind :key
    :db-constraints :not-null
    :type integer)
   (id2
    :db-kind :key
    :db-constraints :not-null
    :type integer)
   (id3
    :db-kind :key
    :db-constraints :not-null
    :type integer
    :initarg :id3))
  (:base-table view-class2))
  

(defregression ('join 1)
    (with-test-db ()
      (let ((vc2-item1 (make-instance 'view-class2 :id3 1))
            (vc2-item2 (make-instance 'view-class2 :id3 2))
            (vc2-item3 (make-instance 'view-class2 :id3 3))
            (vc2-item4 (make-instance 'view-class2 :id3 4))
            (vc1-item1 (make-instance 'view-class1 :id1 0 :id2 1))
            (vc1-item2 (make-instance 'view-class1 :id1 1 :id2 1)))
        (ignore-errors 
          (sql:drop-view-from-class 'view-class1)
          (sql:drop-view-from-class 'view-class2))
        (sql:create-view-from-class 'view-class1)
        (sql:create-view-from-class 'view-class2)
        (sql:add-to-relation vc1-item1 'tests vc2-item1)
        (sql:add-to-relation vc1-item1 'tests vc2-item2)
        (sql:add-to-relation vc1-item2 'tests vc2-item3)
        (sql:add-to-relation vc1-item2 'tests vc2-item4)
        (sql:store-instance vc2-item1)
        (sql:store-instance vc2-item2)
        (sql:store-instance vc2-item3)
        (sql:store-instance vc2-item4)
        (sql:store-instance vc1-item1)
        (sql:store-instance vc1-item2)
        ;; select the test join classes
        (let ((length (length (vc1-tests (car (sql:select 'view-class1))))))
          (unless (= 2 length)
            (error (format t "Expected 2 results, got ~A" length))))))))
