;;; -*- Syntax: Ansi-Common-Lisp; Base: 10; Mode: lisp; Package: wco -*-
;;; $Id: test-metaclass.lisp,v 1.2 2002/10/28 19:00:55 craig Exp $
;;;
;;; Copyright (c) 2000, 2001, 2002 onShore Development, Inc.

(in-package :sql-sys)

;; Preliminary definitions for our tests to work on

(defclass standard-class1 ()
  ((test-slot
    :initform nil
    :initarg :test-slot)))

(def-view-class view-class1 (standard-class1)
  ((foo-oid :db-kind :key
            :initarg :oid
            :type integer))
  (:schemas "sql-tests"))

(def-view-class view-class2 (view-class1)
  ((bar    :db-kind :base
           :initarg :bar
           :type string)
   (baz    :db-kind :virtual
           :initarg :az
           :initform nil)
   (blah   :db-kind :join
           :db-info (:join-class view-class1
                                 :home-key foo-oid
                                 :foreign-key foo-oid
                                 :set nil))))


#-lispworks
(defregression (:metaclass 1)
    "Ensure slots inherited from standard-classes are :virtual"
  (assert (eql :virtual
               (view-class-slot-db-kind (slotdef-for-slot-with-class 'test-slot (pcl::find-class 'view-class1)))))
  (assert (eql :virtual
               (view-class-slot-db-kind (slotdef-for-slot-with-class 'baz (pcl::find-class 'view-class2))))))
#+lispworks
(defregression (:metaclass 1)
    "Ensure slots inherited from standard-classes are :virtual"
  (assert (eql :virtual
               (view-class-slot-db-kind (slotdef-for-slot-with-class 'test-slot (find-class 'view-class1)))))
  (assert (eql :virtual
               (view-class-slot-db-kind (slotdef-for-slot-with-class 'baz (find-class 'view-class2))))))

 
#-lispworks
(defregression (:metaclass 2)
    "Ensure all slots in view-class are view-class-effective-slot-definition"
  (assert (every #'(lambda (slotd)
                     (typep slotd 'view-class-effective-slot-definition))
                 (class-slots (pcl::find-class 'view-class1))))
  (assert (every #'(lambda (slotd)
                     (typep slotd 'view-class-effective-slot-definition))
                 (class-slots (pcl::find-class 'view-class2)))))
  

#+lispworks
(defregression (:metaclass 2)
    "Ensure all slots in view-class are view-class-effective-slot-definition"
  (assert (every #'(lambda (slotd)
                     (typep slotd 'view-class-effective-slot-definition))
                 (class-slots (find-class 'view-class1))))
  (assert (every #'(lambda (slotd)
                     (typep slotd 'view-class-effective-slot-definition))
                 (class-slots (find-class 'view-class2)))))