;;; -*- Syntax: Ansi-Common-Lisp; Base: 10; Mode: lisp; Package: wco -*-
;;; $Id: test-sequences.lisp,v 1.3 2002/10/31 20:04:14 ayres Exp $
;;;
;;; Copyright (c) 2000, 2001, 2002 onShore Development, Inc.

(in-package :sql-sys)

(defregression ('sequences 1)
  "create a sequence"
  (with-test-db (:postgresql)
    (let ((seqname (gensym))
          (val1 nil))
          
      (create-sequence seqname :schema "sql-tests")
      (setf val1 (sequence-next seqname))
      (unwind-protect
           (unless (< val1 (sequence-next seqname))
             (error "Sequence did not increment properly."))
        (drop-sequence seqname)))))

(defregression ('sequences 2)
  "explicitly set the value of a sequence"
  (with-test-db (:postgresql)
    (let ((seqname (gensym))
          (val1 nil))
      (create-sequence seqname :schema "sql-tests")
      (setf val1 (sequence-next seqname))
      (set-sequence-position seqname 5)
      (unwind-protect
           (unless (= (sequence-next seqname) 6)
             (error "Sequence did not set properly."))
        (drop-sequence seqname)))))
