;;; -*- Syntax: Ansi-Common-Lisp; Base: 10; Mode: lisp; Package: wco -*-
;;; $Id: test-types.lisp,v 1.1 2003/01/13 17:38:25 craig Exp $
;;;
;;; Copyright (c) 2000, 2001, 2002 onShore Development, Inc.

(in-package :sql-sys)

(sql:def-view-class wall-time1 ()
  ((time1
    :db-constraints :not-null
    :type wall-time
    :initarg :time1))
  (:base-table wall-time1))


(defregression (:wall-time 1)
    "test wall-time serialization"
  (with-test-db ()
    (let* ((now (get-time))
           (wt1 (make-instance 'wall-time1 :time1 now)))
      (ignore-errors
        (sql:drop-view-from-class 'wall-time1))
      (sql:create-view-from-class 'wall-time1)
      (sql::store-instance wt1)
      (let ((dbobj (car (select 'sql-sys::wall-time1 :where [= [time1] now]))))
        (unless dbobj
          (error "Wall time query failed."))
        (unless (time= (slot-value dbobj 'time1) now)
          (error "Wall time serialization failed, ~A != ~A"
                 (slot-value dbobj 'time1) now)
          )))))


(defregression (:wall-time 2)
    "test wall-time serialization"
  (with-test-db ()
    (let* ((now (get-time))
           (wt1 (make-instance 'wall-time1 :time1 now)))
      (ignore-errors
        (sql:drop-view-from-class 'wall-time1))
      (sql:create-view-from-class 'wall-time1)
      (dotimes (x 40)
        (setf (slot-value wt1 'time1) now)
        (sql::store-instance wt1)
        (let ((dbobj (car (select 'sql-sys::wall-time1
                                  :where [= [time1] now]))))
          (unless dbobj
            (error "Wall time query failed on iteration ~A, looking for ~A."
                   x now))
          (unless (time= (slot-value dbobj 'time1) now)
            (error "Wall time serialization failed, ~A != ~A"
                   (slot-value dbobj 'time1) now))
          (setf now (roll now :day (* 10 x))))))))



